part of viltage;

class Input {
  static HashMap<int, int> _keys = new HashMap<int, int>();
  static HashMap<int, int> _lastKeys = new HashMap<int, int>();
  static HashMap<int, int> _banKeys = new HashMap<int, int>();
  
  static init() {
    window.onKeyDown.listen((KeyboardEvent e) {
      if (!_keys.containsKey(e.keyCode)) {
        _keys[e.keyCode] = e.timeStamp;
      }
    });

    window.onKeyUp.listen((KeyboardEvent e) {
      _keys.remove(e.keyCode);
    });
  }

  static bool isHeld(int keyCode) => _keys.containsKey(keyCode);
  
  static bool isPressed(int keyCode) => _lastKeys.containsKey(keyCode);
  
  static load() {
    for(int i = 0; i < 256; i++) {
       if(_lastKeys.containsKey(i) || _banKeys.containsKey(i)) {
         _lastKeys.remove(i);
         _banKeys[i] = 0;
       } else if(_keys.containsKey(i)) {
         _lastKeys[i]= 0; 
       }
    }
  }
  
  static end() {
    for(int i = 0; i < 256; i++) {
      if(!_keys.containsKey(i)) _banKeys.remove(i);
    }
  }
  
}